#!/usr/bin/env ruby -Ku

require 'net/http'; Net::HTTP.version_1_2
require 'rexml/document'
require 'time'

module Atok_plugin
  def run_process(request)
    # 表示したいカレンダーの非公開URLを設定してください。
    private_xml_url  = '' # XML
    private_html_url = '' # HTML

    candidate = {'alternative_type' => 'url_jump_string', 'alternative' => private_html_url}

    case request['composition_string']
    when 'きょうのよてい'
      today = Time.now.strftime('%Y-%m-%d')
      todays_url = private_xml_url.sub(%r|/basic$|, "/full?start-min=#{today}T00:00:00%2B09:00&start-max=#{today}T23:59:59%2B09:00")
      return nil unless doc = fetch_calendar_document(todays_url)

      candidate['hyoki'] = '今日の予定'

      entries = []
      doc.each_element('/feed/entry'){|e| entries << e}
      candidate['comment'] = entries.map{|entry|
          title = entry.elements['title'].text
          start_time = Time.parse(entry.elements['gd:when/@startTime'].value).strftime('%H:%M')
          end_time   = Time.parse(entry.elements['gd:when/@endTime'].value).strftime('%H:%M')
          "[#{start_time}-#{end_time}] #{title}"
        }.join('\\n')
    else
      return nil
    end

    {'candidate' => [candidate]}
  end

  private
  def fetch_calendar_document(url)
    http_response = Net::HTTP.get_response(URI.parse(url))
    return nil unless http_response.is_a?(Net::HTTPOK)
    REXML::Document.new(http_response.body)
  rescue TimeoutError => evar
    nil
  rescue => evar
    nil
  end
end
